clear all
close all
clc


%% GARDA BOUNDARY
load('GardaLakeBoundary5000')

if exist('gardameshff.edp')
   delete('gardameshff.edp');
end

fileID = fopen('gardameshff.edp','w');

% condition for a closing curve
b = [b;b(1,:)];

% findind where i can't divide
ix = find(abs(diff(b(:,1)')) < 10e-10);
iy = find(abs(diff(b(:,2)')) < 10e-10);

N = length(b);
C= '';
for i=1:N-1
 
    % interval t=[tax,tbx]
    tax  = num2strsign(b(i,1)); tbx  = num2strsign(b(i+1,1));
    % interval t=[tay,tby]
    tay  = num2strsign(b(i,2)); tby  = num2strsign(b(i+1,2));
    % find the line connecting x1 to x2
    x1  = b(i,1);
    mx1 = -b(i,1);
    x2  = b(i+1,1);
    y1  = b(i,2);
    my1 = -b(i,2);
    y2  = b(i+1,2);
    
    % conditions including "strange lines" (ex. vertical ones)
    if ~any(i==ix)
        m(i) = (y2-y1)/(x2-x1);
        fprintf(fileID,'border C%d(t=%s,%s){x=t; y=%6.2f*(t%s)%s;}\n',i,tax,tbx,m(i),num2strsign(mx1),num2strsign(y1));
        if i < N-1
            is = int2str(i);
            C = strcat('C',is,'(1)',C);
        end
    else
        m(i) = (x2-x1)/(y2-y1);
        fprintf(fileID,'border C%d(t=%s,%s){x=%6.2f*(t%s)%s; y=t;}\n',i,tay,tby,m(i),num2strsign(my1),num2strsign(x1));
        if i < N-1
            is = int2str(i);
            C = strcat('C',is,'(1)',C);
        end
    end
    
end

is = int2str(N-1);
C = strcat('C',is,'(1)',C);

nbvx = 50000;
plotstr = strcat('plot(',C,'%s,wait=true);\n');
fprintf(fileID,'plot(%s,wait=true);\n',C)
fprintf(fileID,'mesh Th = buildmesh (%s,nbvx=%d,fixeborder=1);\n',C,nbvx);
fprintf(fileID,'Th = adaptmesh (Th,keepbackvertices=0,iso=1);\n');
fprintf(fileID,'plot(Th,wait=true,ps="gardafreefem.eps");\n')
fprintf(fileID,'savemesh(Th,"gardameshff.msh");');
